﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MbUnit.Framework;

namespace Domain.Tests
{
    public class CustomerTests
    {

        [TestFixture]
        public class When_Creating_Customer
        {
            [Test]
            public void Can_Return_New_Customer()
            {
                var customer = new Customer();
                Assert.IsNotNull(customer);
            }

            [Test]
            public void Customers_Id_is_Default()
            {
                var customer = new Customer();
                Assert.AreEqual(0, customer.Id);
            }

        }

        [TestFixture]
        public class When_Adding_Order
        {
            [Test]
            public void Cannot_Add_Same_Order_Multiple_Times()
            {
                var customer = new Customer();
                var order = new Order();

                customer.AddOrder(order);

                Assert.Throws<ArgumentException>(() => customer.AddOrder(order));

            }

            [Test]
            public void Order_Is_Added()
            {
                var customer = new Customer();
                var order = new Order();
                customer.AddOrder(order);

                Assert.Contains(customer.Orders, order);

            }

        }

    }

}
