using System;
using System.Collections.Generic;

namespace Domain
{
    public class Customer
    {
        private int _id;

        private List<Order> _orders;

        public int Id
        {
            get { return _id; }
        }

        public IEnumerable<Order> Orders
        {
            get
            {
                if (null == _orders)
                    _orders = new List<Order>();

                return _orders;
            }
        }

        public void AddOrder(Order order)
        {
            if (_orders == null)
                _orders = new List<Order>();

            if (_orders.Contains(order))
                throw new ArgumentException("Attempted to add same order twice!");

            _orders.Add(order);
        }

    }
}
