﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MbUnit.Framework;
using Domain;

namespace Service.Tests
{
    public class OrderProcessingServiceTests
    {
        
        [TestFixture]
        public class When_Creating_New_Service
        {
            [Test]
            public void Can_Create_Instance()
            {
                OrderProcessingService service = new OrderProcessingService();
                Assert.IsNotNull(service);
            }


        }

        [TestFixture]
        public class When_Shipping_Valid_Order
        {
            [Test]
            public void Can_Return_Success()
            {
                OrderProcessingService service = new OrderProcessingService();
                Order order = new Order();
                order.AddItem(new Item());

                Customer customer = new Customer();
                customer.AddOrder(order);

                Assert.IsTrue(order.IsValid, "Failed to create necessary valid Order as input to test!");

                bool shippingResult = service.Ship(order, customer);

                Assert.IsTrue(shippingResult);
            }


        }


        [TestFixture]
        public class When_Shipping_Invalid_Order
        {
            [Test]
            public void Can_Report_Failure()
            {
                OrderProcessingService service = new OrderProcessingService();
                Order order = new Order();

                Assert.IsFalse(order.IsValid, "Failed to create necessary invalid Order as input to test!");

                Customer customer = new Customer();
                customer.AddOrder(order);

                bool shippingResult = service.Ship(order, customer);

                Assert.IsFalse(shippingResult);
            }
        }

    }
}
